#include "ANSI.h"

//Create a pallet describing the ansi colors
//This is closest to VGA but no real idea if they are correct
//They will not match your terminal
Image* ansiCreatePallet(){
	vector<Pixel> pal;

	Pixel stds[] = {
		{0,0,0},{128,0,0},{0,128,0},{128,128,0},
		{0,0,128},{128,0,128},{0,128,128},{192,192,192},
		{128,128,128},{255,0,0},{0,255,0},{255,255,0},
		{0,0,255},{255,0,255},{0,255,255},{255,255,255}
	};

	Pixel p;
	for(Pixel q : stds){
		pal.push_back(q);
	}

	int six[] = {0,95,135,175,215,255};
	for(int r = 0; r < 6; ++r){
		for(int g = 0; g < 6; ++g){
			for(int b = 0; b < 6; ++b){
				p = {six[r],six[g],six[b]};
				pal.push_back(p);
			}
		}
	}

	for(int g = 8; g <= 248; g += 10){
		p = {g,g,g};
		pal.push_back(p);
	}
	Image* pallet = createImage(256,1);
	for(int i =0; i < 256; ++i){
		setPixel(pallet,pal[i],i,0);
	}
	return pallet;
}


void ansiImage(Image* img){

	Image* ansiPallet = ansiCreatePallet();//readRGB("ansiPallet.rgb");
	//scale to the screen size should use the ansi code for getting bounds!
	//  twice as many y values as we can show two pixels in each character
	Image* scaled = createImage(185,100);
	backwardMapping(img, scaled,identityMap);
	//dither with ansiPallet
	floydSteinberg(scaled,ansiPallet);

	//debug png image
	//writePng("terminal.png",scaled);

	//ansi lower box character
	char lower[] = {(char)0xE2,(char)0x96,(char)0x84,(char)0x00};


	for(int y =0; y < scaled->height; y += 2){
		for(int x = 0; x < scaled->width; ++x){
			//top pixel
			Pixel p = getPixel(scaled,x,y);
			int bg = indexOfClosestColor(p,ansiPallet);
			//bottom pixel
			p = getPixel(scaled,x,y+1);
			int fg = indexOfClosestColor(p,ansiPallet);
			cout << "\33[48;5;" << bg << "m";
			cout << "\33[38;5;" << fg << "m" << lower;
		}
		//cout << "\n";
	}
}
