#ifndef Image__H
#define Image__H

//this is really a c file
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

typedef struct Image{
	int width;
	int height;
	int channels;
	unsigned char* data;
} Image;

//Should probably move to own file
typedef struct Pixel{
	int red;
	int green;
	int blue;
	int alpha;
} Pixel;


Pixel getSample(Image* img, float u, float v);
void setSample(Image*img,Pixel p, float u, float v);

void setPixel(Image* img,Pixel p,int x,int y);
Pixel getPixel(Image* img,int x,int y);
Image* createImage(int width,int height);
Image* destroyImage(Image* img);

void clearImage(Image* image);

int pixelCompare(Pixel p, Pixel q);
Pixel pixelAdd(Pixel p,Pixel q);
Pixel pixelSub(Pixel p,Pixel q);
Pixel pixelMultiply(Pixel p,Pixel q);
Pixel pixelDivide(Pixel p,Pixel q);
Pixel pixelSubtract(Pixel p, Pixel q);
Pixel pixelMultiplyf(Pixel p, float q);
Pixel pixelAbs(Pixel p);
Pixel pixelPyth(Pixel a,Pixel b);

void printPixel(Pixel p);

Pixel pixelLerp(float t, Pixel p, Pixel q);

float pixelDistance(Pixel p, Pixel q);

void stripAlpha(Image* image);
void addAlpha(Image* image);

void toGray(Image* image);
void blit(Image* src,Image* dest, int a,int b);
void blitMask(Image* src,Image* dest, int a,int b);
#endif
