#ifndef MAPPINGS__H
#define MAPPINGS__H

#include "Image.h"

//The global variable for how much to rotate
//tough solution to the parameter problem -- how to pass parameters and
//keep forwardMapping/backwardMapping still able to work for everything
extern float rotateTheta;

//for each pixel in dest
void backwardMapping(Image* img,Image* dest,void (*map)(float*, float*));
//for each pixel in img
void forwardMapping(Image* img,Image* dest,void (*map)(float*, float*));

void rotateMap(float* u, float* v);
void swirlMap(float* u, float* v);
void sphereMapInverse(float* u, float* v);
void sphereMap(float* u,float *v);
void ringMap(float* u, float* v);
void flipMap(float* u, float* v);
void waveMap(float* u,float *v);
//use identityMap to scale
void identityMap(float *u, float *v);


#endif
