#include "SVG.h"


 string rgb(string type){
	string cmd = type + "=\"rgb(";
 	cmd += to_string(drawColor.red)   + ",";
	cmd += to_string(drawColor.green) + ",";
 	cmd += to_string(drawColor.blue)  + ")\"";
	return cmd;
}

void SVG::fillCircle(Coord c, float radius){
	stringstream cmd;
	cmd << "<circle cx=\"" << c.x << "\" cy=\"" << c.y;
	cmd << "\" r=\"" << radius << "\" ";
	cmd << rgb("fill") << "/>";
	cmds.push_back(cmd.str());
}
void SVG::drawLine(Coord a, Coord b){
	stringstream cmd;
	cmd << "<line x1=\"" << a.x << "\" y1=\"" << a.y;
	cmd << "\" x2=\"" << b.x << "\" y2=\"" << b.y;
	cmd << "\" stroke=\"rgb(" << drawColor.red << "," << drawColor.green << "," << drawColor.blue;
	cmd << "\" stroke-width=\"" << strokeSize << "\"/>";
	cmds.push_back(cmd.str());
}

void SVG::create(int width,int height){
	stringstream cmd;
	cmd << "<svg xmlns=\"http://www.w3.org/2000/svg\" version=\"1.1\"";
	cmd << " width=\"" << width << "\" height=\"" << height << "\">";
	cmds.push_back(cmd.str());
}

void SVG::write(string filename){
	cmds.push_back("</svg>");
	ofstream fout;
	fout.open(filename);
	for(string s: cmds){
		fout << s << "\n";
	}
	fout.close();
}
