#include "Text.h"
#include "font8x8_basic.h"


Image* characterBitmap(char ch){
	Image* img = createImage(8,8);
	unsigned char *character = font8x8_basic[(int)ch];
	for (int x=0; x < 8; x++) {
		for (int y=0; y < 8; y++) {
			if(character[x] & 1 << y){
				setPixel(img,drawColor,y,x);
			}
		}
	}
	return img;
}

float thetaFromTangent(Coord tangent){
	tangent.normalize();
	float theta = acos(tangent.x);
	if(tangent.y > 0)
		theta = 0-theta;
	return theta;
}

void drawTextLine(Image* dest, string text, Coord a, Coord b){
	for(int i =0; i < text.size(); ++i){
		float t = (float)i/(float)(text.size()-1);
		Coord pt = coordLerp(t,a,b);
		drawColor = {0,255,128};
		Image* bit = characterBitmap(text[i]);
		//Image* big = createImage(bit->width*3,bit->height*3);
		//backwardMapping(bit,big,&identityMap);
		Image* rot = rotate(bit,thetaFromTangent(coordLerp(t+0.001,a,b)-pt));
		blitMask(rot,dest,pt.x-rot->width/2,pt.y-rot->height/2);
		//  destroyImage(big);
		destroyImage(bit);
		destroyImage(rot);
	}
}

void drawQuadraticLine(Image* dest, string text, Coord a,Coord b, Coord c){
	for(int i =0; i < text.size(); ++i){
		float t = (float)i/(float)(text.size()-1);
		Coord pt = quadraticBezier(t,a,b,c);
		drawColor = {0,255,128};
		Image* bit = characterBitmap(text[i]);
		//Image* big = createImage(bit->width*3,bit->height*3);
		//backwardMapping(bit,big,&identityMap);
		Image* rot = rotate(bit,thetaFromTangent(quadraticBezier(t+0.001,a,b,c)-pt));
		blitMask(rot,dest,pt.x-rot->width/2,pt.y-rot->height/2);
		//  destroyImage(big);
		destroyImage(bit);
		destroyImage(rot);
	}
	drawQuadraticCurve(dest,a,b,c);
}
