#include "Triangle.h"


float close(float f){
	if(f >= -0.001)
		return fabs(f);
	return f;
}

bool Triangle::inside(Coord p){
	float u,v,w;
	barycentric(p,&u,&v,&w);
	return u >= 0 && v >= 0 && w >= 0;
}


void Triangle::barycentric(Coord p,float* u,float* v,float *w){
	Coord v0 = pt[1]-pt[0];
	Coord v1 = pt[1]-p;
	Coord v2 = pt[2]-p;
	float abc = v0.cross(pt[2]-pt[0])/2;
	float pbc = v1.cross(pt[2]-p)/2;
	float pca = v2.cross(pt[0]-p)/2;
	*u = close(pbc/abc);
	*v = close(pca/abc);
	*w = close(1.0f-*v-*u);
}

Coord Triangle::textureCoord(Coord p){
	float u,v,w;
	barycentric(p,&u,&v,&w);
	return uv[0]*u + uv[1]*v + uv[2]*w;
}
