#include "PNG.h"
#include "ANSI.h"
#include "JPEG.h"
#include "Kernels.h"
#include "Dither.h"
#include "Mappings.h"
#include "Coord.h"
#include "Drawing.h"
#include "Stippling.h"
#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include "SVG.h"
#include "Text.h"
#include "Demo.h"

using namespace std;





void stippleDemo(){
	Image* org = readJpeg("riggo.jpg");
	Image* img = createImage(org->width*2,org->height*2);

	backwardMapping(org,img,identityMap);
	toGray(img);

	vector<Coord> centers = stippling(img,10000,15);
	SVG svg;
	svg.create(img->width,img->height);
	for(Coord c: centers){
		svg.fillCircle(c,2);
	}
	svg.write("test.svg");
}


int main(){
	srand(time(0));

	stippleDemo();
//	textureDemo();
//	shadeDemo();


	return 	0;
}
